Index: lemon/lp_glpk.h
===================================================================
--- lemon/lp_glpk.h	(revision 458)
+++ lemon/lp_glpk.h	(revision 459)
@@ -36,86 +36,135 @@
 
 
+  /// \brief Base interface for the GLPK LP and MIP solver
+  ///
+  /// This class implements the common interface of the GLPK LP and MIP solver.
+  /// \ingroup lp_group
+  class GlpkBase : virtual public LpBase {
+  protected:
+
+    typedef glp_prob LPX;
+    glp_prob* lp;
+
+    GlpkBase();
+    GlpkBase(const GlpkBase&);
+    virtual ~GlpkBase();
+
+  protected:
+
+    virtual int _addCol();
+    virtual int _addRow();
+
+    virtual void _eraseCol(int i);
+    virtual void _eraseRow(int i);
+
+    virtual void _eraseColId(int i);
+    virtual void _eraseRowId(int i);
+
+    virtual void _getColName(int col, std::string& name) const;
+    virtual void _setColName(int col, const std::string& name);
+    virtual int _colByName(const std::string& name) const;
+
+    virtual void _getRowName(int row, std::string& name) const;
+    virtual void _setRowName(int row, const std::string& name);
+    virtual int _rowByName(const std::string& name) const;
+
+    virtual void _setRowCoeffs(int i, ExprIterator b, ExprIterator e);
+    virtual void _getRowCoeffs(int i, InsertIterator b) const;
+
+    virtual void _setColCoeffs(int i, ExprIterator b, ExprIterator e);
+    virtual void _getColCoeffs(int i, InsertIterator b) const;
+
+    virtual void _setCoeff(int row, int col, Value value);
+    virtual Value _getCoeff(int row, int col) const;
+
+    virtual void _setColLowerBound(int i, Value value);
+    virtual Value _getColLowerBound(int i) const;
+
+    virtual void _setColUpperBound(int i, Value value);
+    virtual Value _getColUpperBound(int i) const;
+
+    virtual void _setRowLowerBound(int i, Value value);
+    virtual Value _getRowLowerBound(int i) const;
+
+    virtual void _setRowUpperBound(int i, Value value);
+    virtual Value _getRowUpperBound(int i) const;
+
+    virtual void _setObjCoeffs(ExprIterator b, ExprIterator e);
+    virtual void _getObjCoeffs(InsertIterator b) const;
+
+    virtual void _setObjCoeff(int i, Value obj_coef);
+    virtual Value _getObjCoeff(int i) const;
+
+    virtual void _setSense(Sense);
+    virtual Sense _getSense() const;
+
+    virtual void _clear();
+
+  public:
+
+    ///Pointer to the underlying GLPK data structure.
+    LPX *lpx() {return lp;}
+    ///Const pointer to the underlying GLPK data structure.
+    const LPX *lpx() const {return lp;}
+
+    ///Returns the constraint identifier understood by GLPK.
+    int lpxRow(Row r) const { return rows(id(r)); }
+
+    ///Returns the variable identifier understood by GLPK.
+    int lpxCol(Col c) const { return cols(id(c)); }
+
+  };
+
   /// \brief Interface for the GLPK LP solver
   ///
   /// This class implements an interface for the GLPK LP solver.
   ///\ingroup lp_group
-  class LpGlpk : virtual public LpSolverBase {
-  protected:
-
-    typedef glp_prob LPX;
-    glp_prob* lp;
-    bool solved;
-
-  public:
-
-    typedef LpSolverBase Parent;
-
+  class LpGlpk : public GlpkBase, public LpSolver {
+  public:
+
+    ///\e
     LpGlpk();
-    LpGlpk(const LpGlpk &);
-    ~LpGlpk();
-
-  protected:
-    virtual LpSolverBase* _newLp();
-    virtual LpSolverBase* _copyLp();
-
-    virtual int _addCol();
-    virtual int _addRow();
-    virtual void _eraseCol(int i);
-    virtual void _eraseRow(int i);
-    virtual void _getColName(int col, std::string & name) const;
-    virtual void _setColName(int col, const std::string & name);
-    virtual int _colByName(const std::string& name) const;
-    virtual void _setRowCoeffs(int i, ConstRowIterator b, ConstRowIterator e);
-    virtual void _getRowCoeffs(int i, RowIterator b) const;
-    virtual void _setColCoeffs(int i, ConstColIterator b, ConstColIterator e);
-    virtual void _getColCoeffs(int i, ColIterator b) const;
-    virtual void _setCoeff(int row, int col, Value value);
-    virtual Value _getCoeff(int row, int col) const;
-
-    virtual void _setColLowerBound(int i, Value value);
-    virtual Value _getColLowerBound(int i) const;
-    virtual void _setColUpperBound(int i, Value value);
-    virtual Value _getColUpperBound(int i) const;
-
-    virtual void _setRowBounds(int i, Value lower, Value upper);
-    virtual void _getRowBounds(int i, Value &lb, Value &ub) const;
-    virtual void _setObjCoeff(int i, Value obj_coef);
-    virtual Value _getObjCoeff(int i) const;
-    virtual void _clearObj();
-
-    ///\e
-
-    ///\todo It should be clarified
-    ///
+    ///\e
+    LpGlpk(const LpGlpk&);
+
+  private:
+
+    mutable std::vector<double> _primal_ray;
+    mutable std::vector<double> _dual_ray;
+
+    void _clear_temporals();
+
+  protected:
+
+    virtual LpGlpk* _cloneSolver() const;
+    virtual LpGlpk* _newSolver() const;
+
+    virtual const char* _solverName() const;
+
     virtual SolveExitStatus _solve();
     virtual Value _getPrimal(int i) const;
     virtual Value _getDual(int i) const;
+
     virtual Value _getPrimalValue() const;
-    virtual bool _isBasicCol(int i) const;
-    ///\e
+
+    virtual VarStatus _getColStatus(int i) const;
+    virtual VarStatus _getRowStatus(int i) const;
+
+    virtual Value _getPrimalRay(int i) const;
+    virtual Value _getDualRay(int i) const;
 
     ///\todo It should be clarified
     ///
-    virtual SolutionStatus _getPrimalStatus() const;
-    virtual SolutionStatus _getDualStatus() const;
-    virtual ProblemTypes _getProblemType() const;
-
-    virtual void _setMax();
-    virtual void _setMin();
-
-    virtual bool _isMax() const;
-
-  public:
-    ///Set the verbosity of the messages
-
-    ///Set the verbosity of the messages
-    ///
-    ///\param m is the level of the messages output by the solver routines.
-    ///The possible values are:
-    ///- 0 --- no output (default value)
-    ///- 1 --- error messages only
-    ///- 2 --- normal output
-    ///- 3 --- full output (includes informational messages)
-    void messageLevel(int m);
+    virtual ProblemType _getPrimalType() const;
+    virtual ProblemType _getDualType() const;
+
+  public:
+
+    ///Solve with primal simplex
+    SolveExitStatus solvePrimal();
+
+    ///Solve with dual simplex
+    SolveExitStatus solveDual();
+
     ///Turns on or off the presolver
 
@@ -125,13 +174,84 @@
     void presolver(bool b);
 
-    ///Pointer to the underlying GLPK data structure.
-    LPX *lpx() {return lp;}
-
-    ///Returns the constraint identifier understood by GLPK.
-    int lpxRow(Row r) { return _lpId(r); }
-
-    ///Returns the variable identifier understood by GLPK.
-    int lpxCol(Col c) { return _lpId(c); }
+    ///Enum for \c messageLevel() parameter
+    enum MessageLevel {
+      /// no output (default value)
+      MESSAGE_NO_OUTPUT = 0,
+      /// error messages only
+      MESSAGE_ERROR_MESSAGE = 1,
+      /// normal output
+      MESSAGE_NORMAL_OUTPUT = 2,
+      /// full output (includes informational messages)
+      MESSAGE_FULL_OUTPUT = 3
+    };
+
+  private:
+
+    MessageLevel _message_level;
+
+  public:
+
+    ///Set the verbosity of the messages
+
+    ///Set the verbosity of the messages
+    ///
+    ///\param m is the level of the messages output by the solver routines.
+    void messageLevel(MessageLevel m);
   };
+
+  /// \brief Interface for the GLPK MIP solver
+  ///
+  /// This class implements an interface for the GLPK MIP solver.
+  ///\ingroup lp_group
+  class MipGlpk : public GlpkBase, public MipSolver {
+  public:
+
+    ///\e
+    MipGlpk();
+    ///\e
+    MipGlpk(const MipGlpk&);
+
+  protected:
+
+    virtual MipGlpk* _cloneSolver() const;
+    virtual MipGlpk* _newSolver() const;
+
+    virtual const char* _solverName() const;
+
+    virtual ColTypes _getColType(int col) const;
+    virtual void _setColType(int col, ColTypes col_type);
+
+    virtual SolveExitStatus _solve();
+    virtual ProblemType _getType() const;
+    virtual Value _getSol(int i) const;
+    virtual Value _getSolValue() const;
+
+    ///Enum for \c messageLevel() parameter
+    enum MessageLevel {
+      /// no output (default value)
+      MESSAGE_NO_OUTPUT = 0,
+      /// error messages only
+      MESSAGE_ERROR_MESSAGE = 1,
+      /// normal output
+      MESSAGE_NORMAL_OUTPUT = 2,
+      /// full output (includes informational messages)
+      MESSAGE_FULL_OUTPUT = 3
+    };
+
+  private:
+
+    MessageLevel _message_level;
+
+  public:
+
+    ///Set the verbosity of the messages
+
+    ///Set the verbosity of the messages
+    ///
+    ///\param m is the level of the messages output by the solver routines.
+    void messageLevel(MessageLevel m);
+  };
+
+
 } //END OF NAMESPACE LEMON
 
Index: lemon/lp_skeleton.cc
===================================================================
--- lemon/lp_skeleton.cc	(revision 458)
+++ lemon/lp_skeleton.cc	(revision 459)
@@ -23,164 +23,111 @@
 namespace lemon {
 
-  LpSolverBase* LpSkeleton::_newLp()
-  {
-    LpSolverBase *tmp=0;
-    return tmp;
-  }
-
-  LpSolverBase* LpSkeleton::_copyLp()
-  {
-    LpSolverBase *tmp=0;
-    return tmp;
-  }
-
-  int LpSkeleton::_addCol()
+  int SkeletonSolverBase::_addCol()
   {
     return ++col_num;
   }
 
-  int LpSkeleton::_addRow()
+  int SkeletonSolverBase::_addRow()
   {
     return ++row_num;
   }
 
-  void LpSkeleton::_eraseCol(int ) {
+  void SkeletonSolverBase::_eraseCol(int) {}
+  void SkeletonSolverBase::_eraseRow(int) {}
+
+  void SkeletonSolverBase::_getColName(int, std::string &) const {}
+  void SkeletonSolverBase::_setColName(int, const std::string &) {}
+  int SkeletonSolverBase::_colByName(const std::string&) const { return -1; }
+
+  void SkeletonSolverBase::_getRowName(int, std::string &) const {}
+  void SkeletonSolverBase::_setRowName(int, const std::string &) {}
+  int SkeletonSolverBase::_rowByName(const std::string&) const { return -1; }
+
+  void SkeletonSolverBase::_setRowCoeffs(int, ExprIterator, ExprIterator) {}
+  void SkeletonSolverBase::_getRowCoeffs(int, InsertIterator) const {}
+
+  void SkeletonSolverBase::_setColCoeffs(int, ExprIterator, ExprIterator) {}
+  void SkeletonSolverBase::_getColCoeffs(int, InsertIterator) const {}
+
+  void SkeletonSolverBase::_setCoeff(int, int, Value) {}
+  SkeletonSolverBase::Value SkeletonSolverBase::_getCoeff(int, int) const
+  { return 0; }
+
+  void SkeletonSolverBase::_setColLowerBound(int, Value) {}
+  SkeletonSolverBase::Value SkeletonSolverBase::_getColLowerBound(int) const
+  {  return 0; }
+
+  void SkeletonSolverBase::_setColUpperBound(int, Value) {}
+  SkeletonSolverBase::Value SkeletonSolverBase::_getColUpperBound(int) const
+  {  return 0; }
+
+  void SkeletonSolverBase::_setRowLowerBound(int, Value) {}
+  SkeletonSolverBase::Value SkeletonSolverBase::_getRowLowerBound(int) const
+  {  return 0; }
+
+  void SkeletonSolverBase::_setRowUpperBound(int, Value) {}
+  SkeletonSolverBase::Value SkeletonSolverBase::_getRowUpperBound(int) const
+  {  return 0; }
+
+  void SkeletonSolverBase::_setObjCoeffs(ExprIterator, ExprIterator) {}
+  void SkeletonSolverBase::_getObjCoeffs(InsertIterator) const {};
+
+  void SkeletonSolverBase::_setObjCoeff(int, Value) {}
+  SkeletonSolverBase::Value SkeletonSolverBase::_getObjCoeff(int) const
+  {  return 0; }
+
+  void SkeletonSolverBase::_setSense(Sense) {}
+  SkeletonSolverBase::Sense SkeletonSolverBase::_getSense() const
+  { return MIN; }
+
+  void SkeletonSolverBase::_clear() {
+    row_num = col_num = 0;
   }
 
-  void LpSkeleton::_eraseRow(int) {
-  }
+  LpSkeleton::SolveExitStatus LpSkeleton::_solve() { return SOLVED; }
 
-  void LpSkeleton::_getColName(int, std::string &) const {
-  }
+  LpSkeleton::Value LpSkeleton::_getPrimal(int) const { return 0; }
+  LpSkeleton::Value LpSkeleton::_getDual(int) const { return 0; }
+  LpSkeleton::Value LpSkeleton::_getPrimalValue() const { return 0; }
 
+  LpSkeleton::Value LpSkeleton::_getPrimalRay(int) const { return 0; }
+  LpSkeleton::Value LpSkeleton::_getDualRay(int) const { return 0; }
 
-  void LpSkeleton::_setColName(int, const std::string &) {
-  }
+  LpSkeleton::ProblemType LpSkeleton::_getPrimalType() const
+  { return UNDEFINED; }
 
-  int LpSkeleton::_colByName(const std::string&) const { return -1; }
+  LpSkeleton::ProblemType LpSkeleton::_getDualType() const
+  { return UNDEFINED; }
 
+  LpSkeleton::VarStatus LpSkeleton::_getColStatus(int) const
+  { return BASIC; }
 
-  void LpSkeleton::_setRowCoeffs(int, ConstRowIterator, ConstRowIterator) {
-  }
+  LpSkeleton::VarStatus LpSkeleton::_getRowStatus(int) const
+  { return BASIC; }
 
-  void LpSkeleton::_getRowCoeffs(int, RowIterator) const {
-  }
+  LpSkeleton* LpSkeleton::_newSolver() const
+  { return static_cast<LpSkeleton*>(0); }
 
-  void LpSkeleton::_setColCoeffs(int, ConstColIterator, ConstColIterator) {
-  }
+  LpSkeleton* LpSkeleton::_cloneSolver() const
+  { return static_cast<LpSkeleton*>(0); }
 
-  void LpSkeleton::_getColCoeffs(int, ColIterator) const {
-  }
+  const char* LpSkeleton::_solverName() const { return "LpSkeleton"; }
 
-  void LpSkeleton::_setCoeff(int, int, Value )
-  {
-  }
+  MipSkeleton::SolveExitStatus MipSkeleton::_solve()
+  { return SOLVED; }
 
-  LpSkeleton::Value LpSkeleton::_getCoeff(int, int) const
-  {
-    return 0;
-  }
+  MipSkeleton::Value MipSkeleton::_getSol(int) const { return 0; }
+  MipSkeleton::Value MipSkeleton::_getSolValue() const { return 0; }
 
+  MipSkeleton::ProblemType MipSkeleton::_getType() const
+  { return UNDEFINED; }
 
-  void LpSkeleton::_setColLowerBound(int, Value)
-  {
-  }
+  MipSkeleton* MipSkeleton::_newSolver() const
+  { return static_cast<MipSkeleton*>(0); }
 
-  LpSkeleton::Value LpSkeleton::_getColLowerBound(int) const
-  {
-    return 0;
-  }
+  MipSkeleton* MipSkeleton::_cloneSolver() const
+  { return static_cast<MipSkeleton*>(0); }
 
-  void LpSkeleton::_setColUpperBound(int, Value)
-  {
-  }
-
-  LpSkeleton::Value LpSkeleton::_getColUpperBound(int) const
-  {
-    return 0;
-  }
-
-//   void LpSkeleton::_setRowLowerBound(int, Value)
-//   {
-//   }
-
-//   void LpSkeleton::_setRowUpperBound(int, Value)
-//   {
-//   }
-
-  void LpSkeleton::_setRowBounds(int, Value, Value)
-  {
-  }
-
-  void LpSkeleton::_getRowBounds(int, Value&, Value&) const
-  {
-  }
-
-  void LpSkeleton::_setObjCoeff(int, Value)
-  {
-  }
-
-  LpSkeleton::Value LpSkeleton::_getObjCoeff(int) const
-  {
-    return 0;
-  }
-
-  void LpSkeleton::_setMax()
-  {
-  }
-
-  void LpSkeleton::_setMin()
-  {
-  }
-
-  bool LpSkeleton::_isMax() const
-  {
-    return true;
-  }
-
-
-  void LpSkeleton::_clearObj()
-  {
-  }
-
-  LpSkeleton::SolveExitStatus LpSkeleton::_solve()
-  {
-    return SOLVED;
-  }
-
-  LpSkeleton::Value LpSkeleton::_getPrimal(int) const
-  {
-    return 0;
-  }
-
-  LpSkeleton::Value LpSkeleton::_getDual(int) const
-  {
-    return 0;
-  }
-
-  LpSkeleton::Value LpSkeleton::_getPrimalValue() const
-  {
-    return 0;
-  }
-
-  LpSkeleton::SolutionStatus LpSkeleton::_getPrimalStatus() const
-  {
-    return UNDEFINED;
-  }
-
-  LpSkeleton::SolutionStatus LpSkeleton::_getDualStatus() const
-  {
-    return UNDEFINED;
-  }
-
-  LpSkeleton::ProblemTypes LpSkeleton::_getProblemType() const
-  {
-    return UNKNOWN;
-  }
-
-  bool LpSkeleton::_isBasicCol(int) const
-  {
-    return true;
-  }
+  const char* MipSkeleton::_solverName() const { return "MipSkeleton"; }
 
 } //namespace lemon
Index: lemon/lp_skeleton.h
===================================================================
--- lemon/lp_skeleton.h	(revision 458)
+++ lemon/lp_skeleton.h	(revision 459)
@@ -27,13 +27,12 @@
 
   ///A skeleton class to implement LP solver interfaces
-  class LpSkeleton :public LpSolverBase {
+  class SkeletonSolverBase : public virtual LpBase {
     int col_num,row_num;
 
   protected:
 
-    ///\e
-    virtual LpSolverBase* _newLp();
-    ///\e
-    virtual LpSolverBase* _copyLp();
+    SkeletonSolverBase()
+      : col_num(-1), row_num(-1) {}
+
     /// \e
     virtual int _addCol();
@@ -44,19 +43,27 @@
     /// \e
     virtual void _eraseRow(int i);
-    /// \e
-    virtual void _getColName(int col, std::string & name) const;
-    /// \e
-    virtual void _setColName(int col, const std::string & name);
+
+    /// \e
+    virtual void _getColName(int col, std::string& name) const;
+    /// \e
+    virtual void _setColName(int col, const std::string& name);
     /// \e
     virtual int _colByName(const std::string& name) const;
 
     /// \e
-    virtual void _setRowCoeffs(int i, ConstRowIterator b, ConstRowIterator e);
-    /// \e
-    virtual void _getRowCoeffs(int i, RowIterator b) const;
-    /// \e
-    virtual void _setColCoeffs(int i, ConstColIterator b, ConstColIterator e);
-    /// \e
-    virtual void _getColCoeffs(int i, ColIterator b) const;
+    virtual void _getRowName(int row, std::string& name) const;
+    /// \e
+    virtual void _setRowName(int row, const std::string& name);
+    /// \e
+    virtual int _rowByName(const std::string& name) const;
+
+    /// \e
+    virtual void _setRowCoeffs(int i, ExprIterator b, ExprIterator e);
+    /// \e
+    virtual void _getRowCoeffs(int i, InsertIterator b) const;
+    /// \e
+    virtual void _setColCoeffs(int i, ExprIterator b, ExprIterator e);
+    /// \e
+    virtual void _getColCoeffs(int i, InsertIterator b) const;
 
     /// Set one element of the coefficient matrix
@@ -88,93 +95,132 @@
     virtual Value _getColUpperBound(int i) const;
 
-//     /// The lower bound of a linear expression (row) have to be given by an
-//     /// extended number of type Value, i.e. a finite number of type
-//     /// Value or -\ref INF.
-//     virtual void _setRowLowerBound(int i, Value value);
-//     /// \e
-
-//     /// The upper bound of a linear expression (row) have to be given by an
-//     /// extended number of type Value, i.e. a finite number of type
-//     /// Value or \ref INF.
-//     virtual void _setRowUpperBound(int i, Value value);
-
-    /// The lower and upper bound of a linear expression (row) have to be
-    /// given by an
-    /// extended number of type Value, i.e. a finite number of type
-    /// Value or +/-\ref INF.
-    virtual void _setRowBounds(int i, Value lb, Value ub);
-    /// \e
-
-
-    /// The lower and the upper bound of
-    /// a constraint (row) are
-    /// extended numbers of type Value, i.e.  finite numbers of type
-    /// Value, -\ref INF or \ref INF.
-    virtual void _getRowBounds(int i, Value &lb, Value &ub) const;
-    /// \e
-
-
-    /// \e
-    virtual void _clearObj();
+    /// The lower bound of a constraint (row) have to be given by an
+    /// extended number of type Value, i.e. a finite number of type
+    /// Value or -\ref INF.
+    virtual void _setRowLowerBound(int i, Value value);
+    /// \e
+
+    /// The lower bound of a constraint (row) is an
+    /// extended number of type Value, i.e. a finite number of type
+    /// Value or -\ref INF.
+    virtual Value _getRowLowerBound(int i) const;
+
+    /// The upper bound of a constraint (row) have to be given by an
+    /// extended number of type Value, i.e. a finite number of type
+    /// Value or \ref INF.
+    virtual void _setRowUpperBound(int i, Value value);
+    /// \e
+
+    /// The upper bound of a constraint (row) is an
+    /// extended number of type Value, i.e. a finite number of type
+    /// Value or \ref INF.
+    virtual Value _getRowUpperBound(int i) const;
+
+    /// \e
+    virtual void _setObjCoeffs(ExprIterator b, ExprIterator e);
+    /// \e
+    virtual void _getObjCoeffs(InsertIterator b) const;
+
     /// \e
     virtual void _setObjCoeff(int i, Value obj_coef);
-
     /// \e
     virtual Value _getObjCoeff(int i) const;
 
     ///\e
-
-    ///\bug Wrong interface
-    ///
+    virtual void _setSense(Sense);
+    ///\e
+    virtual Sense _getSense() const;
+
+    ///\e
+    virtual void _clear();
+
+  };
+
+  /// \brief Interface for a skeleton LP solver
+  ///
+  /// This class implements an interface for a skeleton LP solver.
+  ///\ingroup lp_group
+  class LpSkeleton : public SkeletonSolverBase, public LpSolver {
+  public:
+    LpSkeleton() : SkeletonSolverBase(), LpSolver() {}
+
+  protected:
+
+    ///\e
     virtual SolveExitStatus _solve();
 
     ///\e
-
-    ///\bug Wrong interface
-    ///
     virtual Value _getPrimal(int i) const;
-
-    ///\e
-
-    ///\bug Wrong interface
-    ///
+    ///\e
     virtual Value _getDual(int i) const;
 
     ///\e
-
-    ///\bug Wrong interface
-    ///
     virtual Value _getPrimalValue() const;
 
     ///\e
-
-    ///\bug Wrong interface
-    ///
-    virtual SolutionStatus _getPrimalStatus() const;
-
-    ////e
-    virtual SolutionStatus _getDualStatus() const;
-
-
-    ///\e
-    virtual ProblemTypes _getProblemType() const;
-
-    ///\e
-    virtual void _setMax();
-    ///\e
-    virtual void _setMin();
-
-    ///\e
-    virtual bool _isMax() const;
-
-
-
-    ///\e
-    virtual bool _isBasicCol(int i) const;
-
-
-
+    virtual Value _getPrimalRay(int i) const;
+    ///\e
+    virtual Value _getDualRay(int i) const;
+
+    ///\e
+    virtual ProblemType _getPrimalType() const;
+    ///\e
+    virtual ProblemType _getDualType() const;
+
+    ///\e
+    virtual VarStatus _getColStatus(int i) const;
+    ///\e
+    virtual VarStatus _getRowStatus(int i) const;
+
+    ///\e
+    virtual LpSkeleton* _newSolver() const;
+    ///\e
+    virtual LpSkeleton* _cloneSolver() const;
+    ///\e
+    virtual const char* _solverName() const;
+
+  };
+
+  /// \brief Interface for a skeleton MIP solver
+  ///
+  /// This class implements an interface for a skeleton MIP solver.
+  ///\ingroup lp_group
+  class MipSkeleton : public SkeletonSolverBase, public MipSolver {
   public:
-    LpSkeleton() : LpSolverBase(), col_num(0), row_num(0) {}
+    MipSkeleton() : SkeletonSolverBase(), MipSolver() {}
+
+  protected:
+    ///\e
+
+    ///\bug Wrong interface
+    ///
+    virtual SolveExitStatus _solve();
+
+    ///\e
+
+    ///\bug Wrong interface
+    ///
+    virtual Value _getSol(int i) const;
+
+    ///\e
+
+    ///\bug Wrong interface
+    ///
+    virtual Value _getSolValue() const;
+
+    ///\e
+
+    ///\bug Wrong interface
+    ///
+    virtual ProblemType _getType() const;
+
+    ///\e
+    virtual MipSkeleton* _newSolver() const;
+
+    ///\e
+    virtual MipSkeleton* _cloneSolver() const;
+    ///\e
+    virtual const char* _solverName() const;
+
   };
 
